BuildRequires: spring spring-core excalibur-avalon-framework easymock-classextension nlog4j spring-beans
BuildRequires: maven-scm maven2-default-skin
%define _with_java5 1
BuildRequires: /proc
BuildRequires: jpackage-1.5-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


%define with_java5 %{?_with_java5:1}%{!?_with_java5:%{?_without_java5:0}%{!?_without_java5:%{?_java5:%{_java5}}%{!?_java5:0}}}
%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?with_java5:0}}}


Summary:        A Multipurpose Infrastructure for Network Applications
Name:           mina
Version:        1.0.0
Release:        alt2_3jpp1.7
Epoch:		0
Group:          Development/Java
License:        Apache 2.0 License
URL:            http://directory.apache.org/subprojects/mina/
Source0:        %{name}-%{version}.tar.gz
# svn export http://svn.apache.org/repos/asf/directory/releases/mina/1.0.0 mina-1.0.0

Source1:        directory-pom-1.0.4.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml

Patch0:		mina-pom_xml.patch
Patch1:		mina-site_xml.patch

BuildRequires: jpackage-utils >= 0:1.7.1
BuildRequires: maven2-plugins >= 0:2.0.4
BuildRequires: maven2-plugin-antrun
BuildRequires: maven2-plugin-assembly
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-eclipse
BuildRequires: maven2-plugin-site
BuildRequires: maven2-plugin-source
BuildRequires: maven2-plugin-surefire

BuildRequires: saxon
BuildRequires: saxon-scripts
%if ! %{with_java5}
%endif
BuildRequires: junit
BuildRequires: easymock
BuildRequires: slf4j
BuildRequires: backport-util-concurrent
BuildRequires: tl-netty2
BuildRequires: jzlib

%if ! %{with_java5}
%endif
Requires: backport-util-concurrent
Requires: slf4j
Obsoletes:	mina-jdk14 < 0:1.0.0
Provides:	mina-jdk14
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
MINA (Multipurpose Infrastructure for Network Applications) is a
network application framework which helps users develop high
performance and high scalability network applications easily.

%if ! %{with_java5}
THIS PARTIAL RELEASE DOES NOT PROVIDE SSL SUPPORT.
%endif

%package filter-codec-netty
Group:          Development/Java
Summary:        Netty2 filter for %{name}
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: tl-netty2
%if %{gcj_support}
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description filter-codec-netty
%{summary}.

%package filter-compression
Group:          Development/Java
Summary:        JZlib compression filter for %{name}
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: jzlib
%if %{gcj_support}
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description filter-compression
%{summary}.

%if %{with_java5}
%package filter-ssl
Group:          Development/Java
Summary:        SSL filter for %{name}
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: slf4j

%description filter-ssl
%{summary}.

%package integration-jmx
Group:          Development/Java
Summary:        JMX integration for %{name}
Requires: %{name} = %{epoch}:%{version}-%{release}

%description integration-jmx
%{summary}.

%package integration-spring
Group:          Development/Java
Summary:        Spring integration for %{name}
Requires: %{name}-filter-ssl = %{epoch}:%{version}-%{release}
Requires: slf4j
Requires: spring-beans
Requires: spring-core

%description integration-spring
%{summary}.

%package java5
Group:          Development/Java
Summary:        Java5 extensions for %{name}
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: slf4j

%description java5
%{summary}.

%package demo
Group:          Development/Java
Summary:        Examples for %{name}
Requires: %{name}-filter-ssl = %{epoch}:%{version}-%{release}
Requires: %{name}-integration-spring = %{epoch}:%{version}-%{release}
Requires: nlog4j
Requires: spring-context
Requires: spring-support

%description demo
%{summary}.

%endif

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
%{summary}.

%package manual
Group:          Development/Documentation
Summary:        Documents for %{name}

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{version}

%if ! %{with_java5}
%patch0 -b .sav
%endif
%patch1 -b .sav

rm example/src/test/java/org/apache/mina/example/echoserver/AcceptorTest.java
rm example/src/test/java/org/apache/mina/example/echoserver/ConnectorTest.java



%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

for p in $(find . -name "*.pom"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

for p in $(find . -name "*pom.xml"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done
%if ! %{with_java5}
/usr/bin/saxon -o pom-javadoc.xml pom.xml.sav /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
%endif

mkdir -p m2_repo/repository/JPP/maven2/default_poms
cp %{SOURCE1} m2_repo/repository/JPP/maven2/default_poms/org.apache.directory-build.pom
cp pom.xml m2_repo/repository/JPP/maven2/default_poms/org.apache.mina-build.pom


######### hack here !!!!!
mkdir -p m2_repo/repository/org.springframework/
ln -s %_javadir/spring/beans.jar m2_repo/repository/org.springframework/spring-beans.jar
########################



mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%if ! %{with_java5}
export JAVA_HOME=%{_jvmdir}/java-1.4.2
%else
export JAVA_HOME=%{_jvmdir}/java-1.5.0
%endif
MVN=/usr/bin/mvn
#MVN=/usr/bin/mvn-jpp
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.mode=true -Dmaven.test.failure.ignore=true -Djava.awt.headless=true"
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} install
%if ! %{with_java5}
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} -f pom-javadoc.xml -N install
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} site
%else
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} -N site
%endif

%install

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/mina

install -m 644 core/target/%{name}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 filter-codec-netty/target/%{name}-filter-codec-netty-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/filter-codec-netty-%{version}.jar
install -m 644 filter-compression/target/%{name}-filter-compression-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/filter-compression-%{version}.jar
%if %{with_java5}
install -m 644 example/target/%{name}-example-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/example-%{version}.jar
install -m 644 filter-ssl/target/%{name}-filter-ssl-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/filter-ssl-%{version}.jar
install -m 644 integration-jmx/target/%{name}-integration-jmx-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-jmx-%{version}.jar
install -m 644 integration-spring/target/%{name}-integration-spring-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-spring-%{version}.jar
install -m 644 java5/target/%{name}-java5-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/java5-%{version}.jar
%endif

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

pushd $RPM_BUILD_ROOT%{_javadir}
   ln -fs %{name}/core-%{version}.jar %{name}-jdk14-%{version}.jar
   ln -fs %{name}/core.jar %{name}-jdk14.jar
popd

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/site/apidocs*

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/
cp -p core/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post filter-codec-netty
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun filter-codec-netty
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post filter-compression
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun filter-compression
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}/core*.jar
%{_javadir}/%{name}-jdk14*.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/core-%{version}.jar.*
%endif

%files filter-codec-netty
%{_javadir}/%{name}/filter-codec-netty*.jar
%if %{gcj_support}
%{_libdir}/gcj/%{name}/filter-codec-netty-%{version}.jar.*
%endif

%files filter-compression
%{_javadir}/%{name}/filter-compression*.jar
%if %{gcj_support}
%{_libdir}/gcj/%{name}/filter-compression-%{version}.jar.*
%endif

%if %{with_java5}

%files filter-ssl
%{_javadir}/%{name}/filter-ssl*.jar

%files integration-jmx
%{_javadir}/%{name}/integration-jmx*.jar

%files integration-spring
%{_javadir}/%{name}/integration-spring*.jar

%files java5
%{_javadir}/%{name}/java5*.jar

%files demo
%{_javadir}/%{name}/example*.jar


%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%{_docdir}/%{name}-%{version}

%changelog
* Mon Jan 28 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.0.0-alt2_3jpp1.7
- full-fledged build with java 5

* Sun Nov 18 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.0.0-alt1_3jpp1.7
- converted from JPackage by jppimport script

